"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const useLocation = (props) => {
    const {} = props;
    const [response, setResponse] = react_1.default.useState((0, utils_1.isEnvironment)('browser') ? Object.assign({}, window.location) : {});
    const onUpdate = react_1.default.useCallback((0, utils_1.debounce)((value = window.location) => {
        setResponse(Object.assign({}, value));
    }, 40), []);
    const method = react_1.default.useCallback(() => {
        onUpdate();
    }, []);
    react_1.default.useEffect(() => {
        if ((0, utils_1.isEnvironment)('browser'))
            return;
        // New API
        if (window.navigation) {
            window.navigation.addEventListener('navigate', method);
        }
        // Old method
        else {
            window.addEventListener('popstate', method);
            window.addEventListener('hashchange', method);
        }
        return () => {
            // Clean up
            // New API
            if (window.navigation) {
                window.navigation.removeEventListener('navigate', method);
            }
            // Old method
            else {
                window.removeEventListener('popstate', method);
                window.removeEventListener('hashchange', method);
            }
        };
    }, []);
    return response;
};
useLocation.displayName = 'amaui-UseLocation';
exports.default = useLocation;
